/*	
	DEPOTset 1.14
	Author: Christian Wilmanns 17.07.2010
	Contact: cwilmanns@web.de
	
	Copyright Christian Wilmanns, 2006-2010
	
	version history:
	------------------------------------
	v1.140 fixes for new comdirect informer, updatemessage system added
	v1.132 bug fix in tryRegEx() which prevented first match from being added to resultArray
	v1.131 bug fixes (?)
	v1.130 changed display for leopard. not fully compatible with tiger anymore. release version 
	v1.125 added support for different currencies
	v1.124 added daily performance display
	v1.123 changed regex for funds in getStockExchangesFromResponse for A0HGMP
	v1.122 getStockExchanges and setupStockExchanges updated for 531421 
	v1.121 spinning wheel function if list is empty, setupStockExchanges updated for DWS0GM vs A0B6W0
	v1.12 english, fade buttons back
	v1.113 name cut, fond query updated
	v1.112 queryonshow
	v1.111 query updated
	v1.11 first comdirect
	
*/
var versionActual = '1.14';
var versionLatest = null;
var versionNewAvail = false;
var messageGlobal = false; 
var versionUrl = 'http://web.mac.com/cwilmanns/onheavygraphicrotations/DEPOTset_files/DEPOTset.zip'
var quoteTimer = null;
var currentExtent = {x:571, y:220};
var targetExtent = {x:0, y:0};
var canvasWidth = 571;
var getQuotesInterval = 120000;
var selectedRow = null;
var customSortOrder = 'false';
var widgetView;
var depotCurrency;
var currencyTable = ['EUR','USD','GBP','CHF'];
var currencyTableSymbol = ['€','$','£','+'];
var httpReqs = new Array();
var inputShares;
var inputTrade;
var inputStockExchange;
var inputCurrency;
var currencyRates = new Array();
var currencyRatesAccess = false;
var currencyRatesRetrieved = false;

if (window.widget){
	widget.onhide = onhide;
	widget.onshow = onshow;
	widget.onremove = onremove;
}

function onshow() {
	setTimeout('getStockQuotes();',1000);
	if (quoteTimer == null && stockListArray.length>0) {
		quoteTimer = setInterval('getStockQuotes();',getQuotesInterval);
	}
	setTimeout('checkVersion();',3000);
}

function onhide() {
	if (quoteTimer != null) {
		clearInterval(quoteTimer);
		quoteTimer = null;
	}
	widgetView = (getWidgetViewFromPrefs()!=null)? getWidgetViewFromPrefs():1;
	switchView(true);
	
	//switch to front
	selectRow(null,selectedRow,false);
	clearInputBack();
	setDepotNameToDiv(getDepotNameFromPrefs());
	document.getElementById("back").style.display="none";
	document.getElementById("front").style.display="block";
}

function onremove() { }

function getStockQuotes() {
	if (!currencyRatesRetrieved) {
		if (!currencyRatesAccess) getCurrencyRates();
		setTimeout('getStockQuotes()',500);
	}
	else if (stockListArray.length>0) {
		startCacheIndicator('cacheindicatorFrontID');
		for (var i=0;i<stockListArray.length;++i) {
			var stockCode = stockListArray[i][1];
			queryComdirect(stockCode,'quote');
		}
	}
}

function getCurrencyRates() {
	currencyRatesAccess = true;
	queryComdirect('00','currency','http://www.comdirect.de/inf/maerkte/waehrungen.html');
}

function CHTTPReq(type,stockCode,httpReq) {
	this.type = type;
	this.stockCode = stockCode;
	this.httpReq = httpReq;
}

function queryComdirect(stockCode,queryType,stockCodeURL) {
	var httpReq = false;
	var strURL = (stockCodeURL!=null)? stockCodeURL:'http://www.comdirect.de/inf/aktien/detail/uebersicht.html?ID_NOTATION='+stockCode;
	httpReq=new XMLHttpRequest();
	if (httpReq) {
		httpReq.onreadystatechange = httpReqChange;
		httpReq.open("GET",strURL,true);
		
		var tmpHttpReq = new CHTTPReq(queryType,stockCode,httpReq);
		httpReqs.push(tmpHttpReq);
		httpReq.send(null);
	}
}

function httpReqChange() {
	if (httpReqs.length<1) return;
	for (var i=0; i < httpReqs.length; i++) {
		if (httpReqs[i].httpReq.readyState == 4) {
			if (httpReqs[i].httpReq.status == 200 || httpReqs[i].httpReq.status == 304) {
				reqResponseObject = httpReqs[i].httpReq;
				reqResponseText = httpReqs[i].httpReq.responseText;
				reqResponseType = httpReqs[i].type;
				var reqResponseStockCode = httpReqs[i].stockCode;
				httpReqs.splice(i,1); i--;
				var processingLastReq = (httpReqs.length<1)? true:false;
				if (reqResponseType=='quote') handleStockQuote(reqResponseText,reqResponseStockCode,processingLastReq);
				else if (reqResponseType=='lookupSymbol') handleLookupSymbol(reqResponseText,reqResponseStockCode);
					else if (reqResponseType=='lookupName') handleLookupName(reqResponseText,reqResponseStockCode);
						else if (reqResponseType=='currency') handleLookupCurrency(reqResponseText,reqResponseStockCode);
							else if (reqResponseType=='versioncheck') handleVersioncheck(reqResponseObject,processingLastReq);
				
			} else {
				setupErrorDisplay(getLocalizedString('ErrorTransmission')+httpReqs[i].httpReq.status+'.','back');
				setupErrorDisplay(getLocalizedString('ErrorTransmission')+httpReqs[i].httpReq.status+'.','front');
				httpReqs.splice(i,1); i--;
				stopCacheIndicator('cacheindicatorFrontID');
				stopCacheIndicator('cacheindicatorBackID');
			}
		}
	}
}

/*//////////////////////
Handles the response from "quote"-query
parses the resonse for the actual trade values
//////////////////////*/
function handleStockQuote(reqResponseText,reqResponseStockCode,processingLastReq) {
	var stockCode = reqResponseStockCode;
	var stockErrorInfo = getStockNameFromResponse(reqResponseText)+getLocalizedString('ErrorWKN')+getStockWKNFromResponse(reqResponseText)+')';
	var regExTradePriceAndCurrencyStock = /<p class=".+">.+>([\d.,-]+)\s(.[^<\/]+)/i; // new 1.14

	var tradePriceAndCurrency = tryRegEx(reqResponseText,regExTradePriceAndCurrencyStock);
	
	if (tradePriceAndCurrency!=false) {
		var tradePrice = tradePriceAndCurrency[0];
		
		// if tradePrice couldn't be retrieved, set it to "0" and throw an error message
		if (tradePrice == '--') {
			tradePrice = 0;
			setupErrorDisplay(getLocalizedString('ErrorQuote1')+stockErrorInfo+getLocalizedString('ErrorQuote2'),'front');
		}
		// currency couldn't be retrieved, set it to EUR
		var tradePriceCurrency = (tradePriceAndCurrency[1]!=null)?tradePriceAndCurrency[1]:'EUR';
		tradePrice = (tradePriceCurrency == 'BPC')?  toNumber(tradePrice)/100:toNumber(tradePrice);
		
		var regExChangeStock = /<p><b><span class=".+">(\+|\-*)([0-9,]+).+<\/span><\/b>&nbsp;&nbsp;<span class="fcGrey66">\[[\+|\-]*([0-9,]+)\]<\/span><\/p>/i;
		var tradeChange = tryRegEx(reqResponseText,regExChangeStock);

		if (tradeChange!=false) {
			//alert('handleStockQuote:'+stockCode+':[0]'+tradeChange[0]+'[1]'+tradeChange[1]+'[2]'+tradeChange[2]+' Currency:'+tradePriceCurrency);
			var changeDirection = tradeChange[0];
			var changePercent = tradeChange[1];
			var changeAbsolute = tradeChange[2];
			var changeAbsoluteCurrency = tradePriceCurrency;
			
			if (changeAbsoluteCurrency == 'BPC') changeAbsolute = toNumber(changeAbsolute)/100;
			
			var stockArrayInstances = getStockArrayPosition(stockCode);
			if (stockArrayInstances.length>0) {
				for (var i=0;i<stockArrayInstances.length;i++) {
					stockListArray[stockArrayInstances[i]][5] = tradePrice;
					stockListArray[stockArrayInstances[i]][6] = changePercent;
					stockListArray[stockArrayInstances[i]][7] = changeDirection;
					stockListArray[stockArrayInstances[i]][8] = changeAbsolute;
					stockListArray[stockArrayInstances[i]][9] = changeAbsoluteCurrency;
				}
			}
		}
		else setupErrorDisplay(getLocalizedString('ErrorQuote1')+stockErrorInfo+getLocalizedString('ErrorQuote2'),'front');
		if (processingLastReq) { currencyRatesRetrieved = false; setupStockTable('frontfull'); }
	}
	else setupErrorDisplay(getLocalizedString('ErrorQuote1')+stockErrorInfo+getLocalizedString('ErrorQuote2'),'front');
}

/*//////////////////////
Handles the response from currency query
"currencies"-Array holds all the currencies that are globally stored in the "currencyRates"-Array
//////////////////////*/
function handleLookupCurrency(reqResponseText) {
	var trashed;
	currencyRates = new Array();
	currencies = new Array('AUD','CNY','CAD','HKD','CHF','GBP','JPY','USD');
	
	/*
	var regExCurrencyCHF = /EUR\/CHF.+\n*\s*.+<img.+\/>(.+)</i;
	var regExCurrencyCHF = /EUR\/GBP.+\n*\s*.+<img.+\/>(.+)</i;
	var regExCurrencyJPY = /EUR\/JPY.+\n*\s*.+<img.+\/>(.+)</i;
	var regExCurrencyUSD = /EUR\/USD.+\n*\s*.+<img.+\/>(.+)</i;
	*/
	
	for (var i=0;i<currencies.length;i++) {
		var regExCurrency = new RegExp('EUR\/'+currencies[i]+'\n*\s*.*\n*\s*.*\n*\s*.*\n*\s*.*<.+>\n*\s*(.+)','i');
		var currencyRate = tryRegEx(reqResponseText,regExCurrency);
		var tmpArray = new Array(currencies[i]);
		currencyRates[currencyRates.length] = tmpArray.concat(currencyRate);	
	}
	
	// set EUR to 1,00
	currencyRates[currencyRates.length] = ['EUR','1,00'];
	currencyRatesAccess = false;
	currencyRatesRetrieved = true;
}

/*//////////////////////
Handles the lookup for the "symbolInputID" form element input text loses gets blurred, and starts the query
called by:
- httpReqChange()
//////////////////////*/
function handleLookupName(reqResponseText,reqResponseStockCode) {
	var stockCode = getStockWKNFromResponse(reqResponseText);
	var stockName = getStockNameFromResponse(reqResponseText);
	var stockExchanges = getStockExchangesFromResponse(reqResponseText);
	if (stockCode != null && stockName != null) {
		document.getElementById('symbolInputID').value = stockCode;
		document.getElementById('symbolNameID').innerHTML = stockName;
		setupStockExchanges(stockExchanges,reqResponseText);
		stopCacheIndicator('cacheindicatorBackID');
	}
	else {
		setupErrorDisplay(getLocalizedString('ErrorStockNotFound1')+reqResponseStockCode+getLocalizedString('ErrorStockNotFound2'),'back');
	}
	// to be done: multiple select??
}

/*//////////////////////
Handles the lookup for the symbol after the "Eintragen"-Button was clicked. If the lookup is successful, it gets stored in global "stockListArray"
called by:
- httpReqChange()
//////////////////////*/
function handleLookupSymbol(reqResponseText,reqResponseStockCode) {
	var stockWKN = getStockWKNFromResponse(reqResponseText);
	//check for too long WKN
	var wknFilter = /(.+)\..+/gi; // xxx.FSE
	var filterResArray = wknFilter.exec(stockWKN);
	if (stockWKN != false) {
		if (filterResArray && filterResArray.length>1) {
			stockWKN = (filterResArray[1].length>6)? filterResArray[1].substr(-7,6):stockWKN;
		}
		// check if a change stock value ongoing or if a new slot should be opened
		if (selectedRow != null) {
			var stockSlot = selectedRow.getAttribute('tag');
			selectRow(null,selectedRow,false);
		}
		else {
			stockListArray[stockListArray.length] = new Array();
			var stockSlot = stockListArray.length-1;
		}
		 
		stockListArray[stockSlot][0] = getStockNameFromResponse(reqResponseText);
		stockListArray[stockSlot][1] = inputStockExchange;
		stockListArray[stockSlot][2] = stockWKN;
		stockListArray[stockSlot][3] = inputShares;
		stockListArray[stockSlot][4] = inputTrade;
		stockListArray[stockSlot][10] = inputCurrency;
			
		storeStockList();
		targetExtent = getExtent('back');
		resizeCanvas();
		setupElementsAfterResize('back');
		// if a stock was selected for change, set selectedRow to null. setupStockTable('back') will update the display.
		 if (selectedRow != null) selectedRow = null;
		setupStockTable('back');
		setupStockTable('front');
		clearInputBack();
	}
	else setupErrorDisplay(getLocalizedString('ErrorStockNotFound1')+reqResponseStockCode+getLocalizedString('ErrorStockNotFound2'),'back');
	stopCacheIndicator('cacheindicatorBackID');
}

/*//////////////////////
Handles the check for a new version, also capable of displaying a message to the users
called by:
- httpReqChange()
//////////////////////*/
function handleVersioncheck(reqResponseObject,processingLastReq) {
	versionLatest = reqResponseObject.responseXML.getElementsByTagName('version');
	versionLatest = versionLatest[0].firstChild.data;
	if (versionLatest!=null){
		if (parseFloat(versionLatest) > parseFloat(versionActual)){
			versionNewAvail = true;
			displayNewVersion();
		}
	}
	var message = reqResponseObject.responseXML.getElementsByTagName('message');
	message = message[0].firstChild.data;
	if (message!='--') setupErrorDisplay(message,'front',true);
	if (processingLastReq) { setupStockTable('frontfull'); }
}

/*//////////////////////
Displays the new version link
called by:
- handleVersioncheck()
//////////////////////*/
function displayNewVersion() {
	var container = document.getElementById('newVersionID');
	container.style.display = 'block';
	container.innerHTML = '<a href="#" onclick=widgetOpenURL("'+versionUrl+'");></a>';
}

/*//////////////////////
Supply one string to test and unlimited regular expressions to execute. 
If a provided regex is global it gets detected and all matches are returned
//////////////////////*/
function tryRegEx(testString) {
	var returnValue = false;
	for (var i=1; i<arguments.length; i++) {
		if (testString.search(arguments[i])!=-1) {
			if (arguments[i].global) {
				var regExResult = new Array;
				var matchInfo;
				while(matchInfo = arguments[i].exec(testString)) {
					var trashed = matchInfo.shift();
					regExResult[regExResult.length] = matchInfo;
				}
				returnValue = regExResult;
			}
			else {
				var regExResult = arguments[i].exec(testString);
				if (regExResult.length>1) {
					var trashed = regExResult.shift();
					returnValue = regExResult;
				}
			}
		}
	}
	return returnValue;
}

/*//////////////////////
search for stock name in responseHTML, cuts it to 50 characters max.
called by:
- handleLookupName()
- handleLookupSymbol()
//////////////////////*/
function getStockNameFromResponse(reqResponseText) {
	var regExNameStockVar1 = /<h1>\s*(.+)\s/i;
	var regExNameStockVar2 = /<h1>\s*<span title="(.+)"/i;
	var stockName = tryRegEx(reqResponseText,regExNameStockVar1,regExNameStockVar2);
	stockName[0] = (stockName == false)? null:(stockName[0].indexOf(',') > -1)? stockName[0].split(',').join('.').substr(0,50):stockName[0].substr(0,50);
	return stockName[0];
}

/*//////////////////////
called by:
- handleLookupName()
//////////////////////*/
function getStockExchangesFromResponse(reqResponseText) {
	//var regExExchangesStock = /value="\/html\/detail\/main\.html\?sSym=([\w\.]+)[^"]+">([^<]+)<\/option>/gi; //"
	var regExExchanges = /<option value="([\w]+)">(.+)</gi;
	return  tryRegEx(reqResponseText,regExExchanges);
}

/*//////////////////////
called by:
- handleLookupName()
- handleLookupSymbol()
//////////////////////*/
function getStockWKNFromResponse(reqResponseText) {
	var regExWKNStock = />WKN<\/.+>\s*<.+>(.+)</i;
	var regExWKNCertificate = /WKN: (.+)</i
	return tryRegEx(reqResponseText,regExWKNStock,regExWKNCertificate);
}

/*//////////////////////
called by:
- buttonLookupID -> "Eintragen"-Button
//////////////////////*/
function insertSymbol() {
	var stockWKN = document.getElementById('symbolInputID').value;
	var shares = toNumber(document.getElementById('sharesInputID').value);
	var trade = toNumber(document.getElementById('tradeInputID').value);
	var stockExchange = getStockExchangeCode();
	var stockCurrency = getCurrencyFromInput('stockCurrencyInput');
	if (stockWKN!='' && shares!='' && trade!='' && !isNaN(shares) && !isNaN(trade) && stockWKN!=null && shares!=null && trade!=null && stockExchange!='null') {
		startCacheIndicator('cacheindicatorBackID');
		// store input global
		inputShares = shares;
		inputTrade = trade;
		inputStockExchange = stockExchange;
		inputCurrency = stockCurrency;
		queryComdirect(inputStockExchange,'lookupSymbol');
	}
}

/*//////////////////////
Retrieves the selected value from the "select"-element "selectStockExchangeID" and returns it to the caller
called by:
- insertSymbol()
//////////////////////*/
function getStockExchangeCode() {
	var elem = document.getElementById('selectStockExchangeID');
	if(elem.selectedIndex>-1){
		var chosenOption = elem.options[elem.selectedIndex].value;
		var returnValue = (chosenOption!='null')? chosenOption:'null';
		if (chosenOption!='null') {
			removeAllChildren(elem);
			elem.style.display = 'none';
			elem.blur();
		}
	}
	else returnValue = 'null';
	return returnValue;
}

/*//////////////////////
Retrieves the value from "symbolInputID" form element input text, and starts the query
called by:
- "symbolInputID"-input on widget's back
//////////////////////*/
function lookupName() {
	startCacheIndicator('cacheindicatorBackID');
	document.getElementById('symbolNameID').innerHTML = '';
	document.getElementById('errorDisplayBackID').style.display = 'none';
	var stockCode = document.getElementById('symbolInputID').value;
	// http://www.comdirect.de/inf/search/all.html?SEARCH_VALUE=
	if (stockCode!='') queryComdirect(stockCode,'lookupName','http://www.comdirect.de/inf/search/all.html?SEARCH_VALUE='+stockCode);
	else stopCacheIndicator('cacheindicatorBackID');
}

function getStockArrayPosition(stockCode) {
	var c = stockListArray.length;
	var stockInstances = new Array();
	for (var i=0;i<c;++i) {
		if (stockListArray[i][1] == stockCode) stockInstances[stockInstances.length] = i;
		//alert('stockListArray['+i+'][1]='+stockListArray[i][1]+' == '+stockCode);
	}
	return stockInstances;
}

function cleanValueForDisplay(toClean,appendix) {
	if (toClean!=null) {
		var toClean = toClean.toString();
		var valueParts = (toClean.indexOf(',')!=-1)? toClean.split(','):(toClean.indexOf('.')!=-1)? toClean.split('.'):toClean.split(' ');
		
		if (typeof(valueParts[1])=='undefined') valueParts[1] = '00';
		else {
			valueParts[1] = valueParts[1].toString().substr(0,2);
			valueParts[1] = (valueParts[1]==0)? '00':(valueParts[1].length==1)? valueParts[1]+'0':valueParts[1];
		}
		
		if (valueParts[0]=='') valueParts[0] = '0'; // for the toFixed return values used in currency convert
		var delimiter = Math.floor((valueParts[0].length-1)/3);
		for (var i=0;i<delimiter;i++) {
			if (valueParts[0].substr(0,valueParts[0].length-(((i+1)*3)+i))!='-') {
				valueParts[0] = (valueParts[0].substr(0,valueParts[0].length-(((i+1)*3)+i)))+'.'+(valueParts[0].substr(valueParts[0].length-(((i+1)*3)+i)));
			}
		}
		toClean = valueParts.join('&#44;');
	}
	return (appendix!=null? toClean+appendix:toClean);
}

function toNumber(value) {
	if (value!=null) {
		value = value.toString();
		value = (value.indexOf(',')!=-1)? value.split(',').join('.'):value;
		//check for more than one delimiter by large values over 1000;
		valueSegments = value.split('.');
		if (valueSegments.length>1) {
			var tmp = '';
			for (var i=0;i<valueSegments.length;i++) {
				tmp += (i==valueSegments.length-1)? '.'+valueSegments[i]:valueSegments[i];
			}
			value = tmp;
		}
	}
	return parseFloat(value);
}

function setOverall() {
	var shares = document.getElementById('sharesInputID').value;
	var trade = document.getElementById('tradeInputID').value;
	var overallValue = getOverallTrade(shares,trade);
	if (overallValue>0) document.getElementById('overallValueID').innerHTML = cleanValueForDisplay(overallValue,' '+currencyTableSymbol[getCurrencyFromInput('stockCurrencyInput')]);
}

function getOverallTrade(shares,trade) {
	return ( toNumber(shares)*toNumber(trade) );
}

function getPerformanceDailyAbs(shares,changeDirection,tradeActual) {
	return ( getOverallTrade(shares,changeDirection+tradeActual) ) ;
}

function getOverallDepotPerformanceDailyPercent() {
	return ( getOverallDepotPerformanceDailyAbs() / (getOverallDepotTradeActual() / 100 )  );
}

function getPerformanceAbs(shares,trade,tradeActual) {
	return ( getOverallTrade(shares,tradeActual) - getOverallTrade(shares,trade) ) ;
}

function getPerformancePercent(shares,trade,tradeActual) {
	return ( getPerformanceAbs(shares,trade,tradeActual) / getOverallTrade(shares,trade) * 100 );
}

function getOverallDepotPerformancePercent() {
	return ( getOverallDepotPerformanceAbs() / getOverallDepotTrade() * 100 );
}

function getOverallDepotTrade() {
	var overallDepotTrade = 0;
	for (var i=0;i<stockListArray.length;++i) {
		//alert(getOverallTrade(stockListArray[i][3],getCalculatedCurrencyValue(stockListArray[i][4],currencyTable[stockListArray[i][10]],currencyTable[depotCurrency])));
		overallDepotTrade += getOverallTrade(stockListArray[i][3],getCalculatedCurrencyValue(stockListArray[i][4],currencyTable[stockListArray[i][10]],currencyTable[depotCurrency]));
	}
	return overallDepotTrade;
}

function getOverallDepotTradeActual() {
	var overallDepotTradeActual = 0;
	for (var i=0;i<stockListArray.length;++i) {
		overallDepotTradeActual += getOverallTrade(stockListArray[i][3],getCalculatedCurrencyValue(stockListArray[i][5],stockListArray[i][9],currencyTable[depotCurrency]));
	}
	return overallDepotTradeActual;
}

function getOverallDepotPerformanceDailyAbs() {
	var overallDepotPerformanceDailyAbs = 0;
	for (var i=0;i<stockListArray.length;++i) {
		overallDepotPerformanceDailyAbs += 
			getCalculatedCurrencyValue(
				getPerformanceDailyAbs(
					stockListArray[i][3],
					stockListArray[i][7],
					getCalculatedCurrencyValue(
						stockListArray[i][8],
						stockListArray[i][9],
						currencyTable[stockListArray[i][10]]
					)
				),
				currencyTable[stockListArray[i][10]],
				currencyTable[depotCurrency]
			);
	}
	return overallDepotPerformanceDailyAbs;
}

function getOverallDepotPerformanceAbs() {
	var overallDepotPerformanceAbs = 0;
	for (var i=0;i<stockListArray.length;++i) {
		overallDepotPerformanceAbs += 
			getCalculatedCurrencyValue(
				getPerformanceAbs(
					stockListArray[i][3],
					stockListArray[i][4],
					getCalculatedCurrencyValue(
						stockListArray[i][5],
						stockListArray[i][9],
						currencyTable[stockListArray[i][10]]
					)
				),
				currencyTable[stockListArray[i][10]],
				currencyTable[depotCurrency]
			);
	}
	return overallDepotPerformanceAbs;
}

/*//////////////////////
called by:
- setOverallDepotPerformanceAbs()
- createRow()
//////////////////////*/
function getCalculatedCurrencyValue(value,fromCurrency,toCurrency) {
	/*
	if (fromCurrency == 'BPC') {
		value = toNumber(value)/10;
		fromCurrency = 'GBP';
		toCurrency = 'GBP';
	}
	*/
	/*
	if (toCurrency == 'EUR') {
		for (var i=0;i<currencyRates.length;i++) {
			if (fromCurrency==currencyRates[i][0]) var factor = 1/toNumber(currencyRates[i][1]);
		}
	}
	else {
		for (var i=0;i<currencyRates.length;i++) {
			if (toCurrency==currencyRates[i][0]) {
				var factor = (fromCurrency!=toCurrency)? currencyRates[i][1]:1;
				if (fromCurrency=='GBP' && toCurrency=='USD') {
					alert('factor = ('+fromCurrency+'!='+toCurrency+')? '+currencyRates[i][1]+':1');
					alert(factor);
				}
				
			}
		}
	}
	*/
	if (fromCurrency == 'BPC') {
		fromCurrency = 'GBP';
		value /= 10;
	}
	for (var i=0;i<currencyRates.length;i++) {
		if (fromCurrency==currencyRates[i][0]) var fromFactor = currencyRates[i][1];
		if (toCurrency==currencyRates[i][0]) var toFactor = currencyRates[i][1];
	}
	//alert(typeof(value)+':'+value);
	return toNumber(toFactor)/toNumber(fromFactor)*toNumber(value);
}

function setOverallDepotTrade() {
	document.getElementById('overallDepotTradeID').innerHTML = cleanValueForDisplay(getOverallDepotTrade(),' '+currencyTableSymbol[depotCurrency]);
}

function setOverallDepotTradeActual() {
	document.getElementById('overallDepotTradeActualID').innerHTML = cleanValueForDisplay(getOverallDepotTradeActual(),' '+currencyTableSymbol[depotCurrency]);
}

function setOverallDepotPerformanceDailyAbs() {
	document.getElementById('overallDepotPerformanceDailyAbsID').innerHTML = cleanValueForDisplay(getOverallDepotPerformanceDailyAbs(),' '+currencyTableSymbol[depotCurrency]);
}

function setOverallDepotPerformanceDailyPercent() {
	document.getElementById('overallDepotPerformanceDailyPercentID').innerHTML = cleanValueForDisplay(isNaN(getOverallDepotPerformanceDailyPercent())? 0:getOverallDepotPerformanceDailyPercent(),'%');
}

function setOverallDepotPerformanceDailyIndicator() {
	document.getElementById('overallDepotPerformanceDailyIndicatorID').innerHTML = (getOverallDepotPerformanceDailyAbs()>0)? '<img src="Images/up_daily.gif" />':'<img src="Images/down_daily.gif" />';
}

function setOverallDepotPerformanceAbs() {
	document.getElementById('overallDepotPerformanceAbsID').innerHTML = cleanValueForDisplay(getOverallDepotPerformanceAbs(),' '+currencyTableSymbol[depotCurrency]);
}

function setOverallDepotPerformancePercent() {
	document.getElementById('overallDepotPerformancePercentID').innerHTML = cleanValueForDisplay(isNaN(getOverallDepotPerformancePercent())? 0:getOverallDepotPerformancePercent(),'%');
}

function setOverallDepotPerformanceIndicatorID() {
	document.getElementById('overallDepotPerformanceIndicatorID').innerHTML = (getOverallDepotPerformanceAbs()>0)? '<img src="Images/up.png" />':'<img src="Images/down.png" />';
}

function setDepotNameToInput(depotName) {
	document.getElementById('depotNameInputID').value = (depotName=='' || depotName==null)? getLocalizedString('Mein Depot'):depotName;
}

function setDepotNameToDiv(depotName) {
	document.getElementById('depotNameDisplayID').innerHTML = (depotName=='' || depotName==null)? getLocalizedString('Mein Depot'):depotName;
}

function setCurrencyToInput(inputId,currency) {
	var container = document.getElementById(inputId);
	for (var i=0;i<container.childNodes.length; i++) {
		if (container.childNodes[i].tagName == 'LI') {
			container.childNodes[i].childNodes[0].className = (container.childNodes[i].id == currency)? 'act':'';
			container.childNodes[i].childNodes[0].childNodes[0].src = (container.childNodes[i].id == currency)? container.childNodes[i].childNodes[0].childNodes[0].src.split('lo').join('ac'):container.childNodes[i].childNodes[0].childNodes[0].src.split('ac').join('lo');
		}
	}
}

function getDepotNameFromInput() {
	var depotName = document.getElementById('depotNameInputID').value;
	return ( depotName=='' || depotName==null ? getLocalizedString('Mein Depot'):depotName );
}

function getDepotNameFromPrefs() {
	return widget.preferenceForKey(createKey('depotname'));
}

function getDepotCurrencyFromPrefs() {
	return widget.preferenceForKey(createKey('depotcurrency'));
}

function getCustomSortOrderFromPrefs() {
	return widget.preferenceForKey(createKey('customsortorder'));
}

function getWidgetViewFromPrefs() {
	return widget.preferenceForKey(createKey('widgetview'));
}

function setVersionDisplay() {
	var container = document.getElementById('versionDisplayID');
	container.innerHTML = '<a href="#" onclick=widgetOpenURL("http://web.mac.com/cwilmanns/onheavygraphicrotations/DEPOTset.html?aid='+versionActual+'");>Version '+versionActual+'</a>';
}

/*//////////////////////
Handles the setup of the stock exchanges select. Works for "normal" values, just one option in source select and no existing source select. Last two options used in "Fonds"
called by:
handleLookupName()
//////////////////////*/
function setupStockExchanges(stockExchangesArray,reqResponseText) {
	var container = document.getElementById('selectStockExchangeID');
	if (container!=null) {
		removeAllChildren(container);
		var firstOption = document.createElement('option');
		firstOption.setAttribute('value',null);
		firstOption.innerHTML = getLocalizedString('Börsenplatz');
		container.appendChild(firstOption);
		if (stockExchangesArray == false){
			var regExExchangesNoSelect = /main.html\?[\s\S]+&lSyms=([\w\.]+)&/i;
			stockExchangesArray = tryRegEx(reqResponseText,regExExchangesNoSelect);
		}
		if (typeof(stockExchangesArray[0])!='string') {
			for (var i=0;i<stockExchangesArray.length;i++) {
				var stockExchangeCode = stockExchangesArray[i][0];
				var stockExchangeName = stockExchangesArray[i][1];
				if (stockExchangeName.indexOf('VIRT-X')<0) {
					var selectOption = document.createElement('option');
					selectOption.setAttribute('value',stockExchangeCode);
					if (selectedRow != null && stockListArray[selectedRow.getAttribute('tag')][1] == stockExchangeCode) selectOption.setAttribute('selected','selected');
					selectOption.innerHTML = stockExchangeName;
					container.appendChild(selectOption);
				}
			}
		}
		else {
			var stockExchangeCode = (stockExchangesArray.length>1)? stockExchangesArray[1]:stockExchangesArray[0];
			var stockExchangeName = (stockExchangesArray.length>1)? stockExchangesArray[0]:getLocalizedString('Fondsgesellschaft');
			var selectOption = document.createElement('option');
			selectOption.setAttribute('value',stockExchangeCode);
			if (selectedRow != null && stockListArray[selectedRow.getAttribute('tag')][1] == stockExchangeCode) selectOption.setAttribute('selected','selected');
			selectOption.innerHTML = stockExchangeName;
			container.appendChild(selectOption);
		}
		container.style.display='block';
	}
}

/*//////////////////////
Handles the display on an error.
called by:
- handleLookupName()
//////////////////////*/
function setupErrorDisplay(errorCode,side,message) {
	var errorDisplayContainer = (side == 'back')? document.getElementById('errorDisplayBackID'):document.getElementById('errorDisplayFrontID');
	if (!messageGlobal) {
		errorDisplayContainer.innerHTML = '<img src="Images/error.png" /><div class="errorText">'+errorCode+'</div>';
		if (side == 'back') document.getElementById('symbolNameID').innerHTML = '';
		errorDisplayContainer.style.display = 'block';
	}
	if (message) messageGlobal = true;
	stopCacheIndicator('cacheindicatorFrontID');
	stopCacheIndicator('cacheindicatorBackID');
}

function widgetOpenURL(URLToOpen) {
	if (window.widget) widget.openURL(URLToOpen);
}

/*//////////////////////
called by:
- hidePrefs()
- onhide
- handleLookupSymbol
//////////////////////*/
function clearInputBack() {
	document.getElementById('symbolInputID').value = '';
	document.getElementById('symbolNameID').innerHTML = '';
	document.getElementById('selectStockExchangeID').style.display = 'none';
	removeAllChildren(document.getElementById('selectStockExchangeID'));
	document.getElementById('sharesInputID').value = '';
	document.getElementById('tradeInputID').value = '';
	document.getElementById('overallValueID').innerHTML = '';
	setCurrencyToInput('stockCurrencyInput',0)
}

function pushStockValuesToInput(index) {
	var stockWKN = stockListArray[index][2];
	var stockShares = stockListArray[index][3];
	var stockTrade = stockListArray[index][4];
	var stockCurrency = stockListArray[index][10];
	
	document.getElementById('symbolInputID').value = stockWKN;
	document.getElementById('sharesInputID').value = stockShares;
	document.getElementById('tradeInputID').value = stockTrade;
	setCurrencyToInput('stockCurrencyInput',stockCurrency);
	lookupName();
}

/*//////////////////////
Pushed the selected stock values to the appropriate input fields
called by:
- "symbolChangeID"-input on widget's back
//////////////////////*/
function changeSymbol() {
	if (selectedRow!=null) {
		var symbolToChange = selectedRow.getAttribute('tag');
		pushStockValuesToInput(symbolToChange);
	}
}

function moveSymbolUp() {
	moveSymbol('up');
}

function moveSymbolDown() {
	moveSymbol('down');
}

function moveSymbol(direction) {
	if (selectedRow!=null) {
		var symbolToMove = parseInt(selectedRow.getAttribute('tag'));
		stockListArray = moveSymbolInArray(stockListArray,symbolToMove,direction);
		
		if (direction=='up') var symbolToSelect = (symbolToMove-1>0)? symbolToMove-1:0;
		else var symbolToSelect = (symbolToMove+1<stockListArray.length)? symbolToMove+1:stockListArray.length-1;
		
		customSortOrder = 'true';
		selectRow(null,document.getElementById(symbolToSelect),true);
	}
}

function moveSymbolInArray(srcArray,index,action) {
	var tmpArray = new Array();
	if (action == 'up') {
		for (var i=0;i<srcArray.length;i++) {
			if (index>0) {
				if (i!=index-1) tmpArray.push(srcArray[i]);
				else {
					tmpArray.push(srcArray[index]);
					tmpArray.push(srcArray[i]);
					i++;
				}
			}
			else tmpArray.push(srcArray[i]);
		}
	}
	if (action == 'down') {
		for (var i=0;i<srcArray.length;i++) {
			if (index+1<srcArray.length) {
				if (i!=index) tmpArray.push(srcArray[i]);
				else {
					tmpArray.push(srcArray[i+1]);
					tmpArray.push(srcArray[index]);
					i++;
				}
			}
			else tmpArray.push(srcArray[i]);
		}
	}
	return tmpArray;
}

function deleteSymbol() {
	if (selectedRow!=null) {
		var symbolToRemovePosition = selectedRow.getAttribute('tag');
		stockListArray = removeSymbolFromArray(stockListArray,symbolToRemovePosition);
		storeStockList();
		targetExtent = getExtent('back');
		resizeCanvas();
		setupElementsAfterResize('back');
		selectRow(null,selectedRow,false);
		fadeButtonsBack(0);
		setupStockTable('front');
		setupStockTable('back');
	}
}

function removeAllChildren(parent) {
	while (parent.hasChildNodes()) parent.removeChild(parent.firstChild);
}

function removeSymbolFromArray(srcArray,index) {
	var tmpArray = new Array();
	for (var i=0;i<srcArray.length;i++) if (i!=index) tmpArray.push(srcArray[i]);
	return tmpArray;
}

function setupStockLink(stockCode,stockName) {
	return '<a href="#" class="stockLink" onclick=widgetOpenURL("http://www.comdirect.de/inf/aktien/detail/uebersicht.html?ID_NOTATION='+stockCode+'")>'+stockName+'</a>';
}

function createCell(cellName,cellValue,wrapInDiv) {
	var td=document.createElement('td');
	td.setAttribute('class',cellName);
	td.innerHTML= (wrapInDiv!=null)? '<div class="tblData">'+cellValue+'</div>':cellValue;
	return td;
}

function createCellTwoRows(cellName,valueOne,valueTwo) {
	var td=document.createElement('td');
	td.setAttribute('class',cellName);
	td.innerHTML= '<div class="rowOne"><div class="tblData">'+valueOne+'</div></div><div class="rowTwo"><div class="tblData">'+valueTwo+'</div></div>';
	return td;
}

function createRow(index,view,lastRow){
	
	var stockName = stockListArray[index][0];
	var stockCode = stockListArray[index][1];
	var stockWKN = stockListArray[index][2];
	var stockShares = stockListArray[index][3];
	var stockTrade = stockListArray[index][4];
	var stockTradeActual = stockListArray[index][5];
	var stockChangePercent = stockListArray[index][6];
	var stockChangeDirection = stockListArray[index][7];
	var stockChangeAbsolute = stockListArray[index][8];
	var stockBaseCurrency = stockListArray[index][9];
	var stockTargetCurrency = currencyTable[stockListArray[index][10]];
	var stockChangeDirectionImg = (stockListArray[index][7]=='-')? '<img src="Images/down_change.gif" class="changeDirection" />':'<img src="Images/up_change.gif" class="changeDirection" />';
	
	//alert(stockName+':'+stockChangeAbsolute+stockBaseCurrency);
	var row = document.createElement('tr');
	
	if (selectedRow!=null && view=='back') {
		var stockRowClass = (selectedRow.getAttribute('tag')==index)? 'stockRowSelected':(lastRow==true)? 'stockRowLast':'stockRow';
	}
	else var stockRowClass = (lastRow==true)? 'stockRowLast':'stockRow';
	var rowClass = ((index%2)!=0)? stockRowClass+' even':stockRowClass+' odd';
	
	if (view=='front') {
		row.setAttribute('class',rowClass);
		row.setAttribute('id',index);
		row.setAttribute('tag',index);
		row.appendChild(createCell('stockShares',''));
		row.appendChild(createCell('stockName',stockName,true));
		row.appendChild(createCell('stockTrade',''));
		row.appendChild(createCell('stockTradeActual',''));
		row.appendChild(createCell('stockPerformanceDay',''));
		row.appendChild(createCell('stockPerformance',''));
		row.appendChild(createCell('stockChangeDirection',''));
	}
	else if (view=='back') {
			row.setAttribute('class',rowClass);
			row.setAttribute('onclick','selectRow(event,this,false);');
			row.setAttribute('id',index);
			row.setAttribute('tag',index);
			row.appendChild(createCell('stockCode',stockWKN,true)); //display WKN instead of stockCode(ISIN)
			row.appendChild(createCell('stockName',stockName,true));
			row.appendChild(createCell('stockShares',cleanValueForDisplay(stockShares),true));
			row.appendChild(createCell('stockTrade',cleanValueForDisplay(stockTrade,' '+currencyTableSymbol[stockListArray[index][10]]),true));
		}
		else if (view=='frontfull') {
			//alert('getPerformanceAbs('+stockShares+','+stockTrade+','+getCalculatedCurrencyValue(stockTradeActual,stockBaseCurrency,stockTargetCurrency)+')');
			var stockPerformanceDirection = (getPerformanceAbs(stockShares,stockTrade,getCalculatedCurrencyValue(stockTradeActual,stockBaseCurrency,stockTargetCurrency))>0)? '<img src="Images/up.png" />':'<img src="Images/down.png" />';
			
			stockTradeActual = getCalculatedCurrencyValue(stockTradeActual,stockBaseCurrency,stockTargetCurrency);
			stockChangeAbsolute = getCalculatedCurrencyValue(stockChangeAbsolute,stockBaseCurrency,stockTargetCurrency);

			row.setAttribute('class',rowClass);
			row.setAttribute('id',index);
			row.setAttribute('tag',index);
			row.appendChild(createCell('stockShares',cleanValueForDisplay(stockShares),true));
			row.appendChild(createCell('stockName',setupStockLink(stockCode,stockName),true));
			row.appendChild(createCellTwoRows('stockTrade',cleanValueForDisplay(stockTrade,' '+currencyTableSymbol[stockListArray[index][10]]),cleanValueForDisplay(getOverallTrade(stockShares,stockTrade),' '+currencyTableSymbol[stockListArray[index][10]])));
			row.appendChild(createCellTwoRows('stockTradeActual',cleanValueForDisplay(stockTradeActual,' '+currencyTableSymbol[stockListArray[index][10]]),cleanValueForDisplay(getOverallTrade(stockShares,stockTradeActual),' '+currencyTableSymbol[stockListArray[index][10]])));
			row.appendChild(createCellTwoRows('stockPerformanceDay',stockChangeDirection+stockChangePercent+stockChangeDirectionImg,stockChangeDirection+cleanValueForDisplay(stockChangeAbsolute,' '+currencyTableSymbol[stockListArray[index][10]])));
			row.appendChild(createCellTwoRows('stockPerformance',cleanValueForDisplay(getPerformancePercent(stockShares,stockTrade,stockTradeActual),'%'),cleanValueForDisplay(getPerformanceAbs(stockShares,stockTrade,stockTradeActual),' '+currencyTableSymbol[stockListArray[index][10]])));
			row.appendChild(createCell('stockChangeDirection',stockPerformanceDirection));
		}
	return row;
}

function setupStockTable(view) {
	if (customSortOrder=='false' || customSortOrder==null) stockListArray.sort();
	var container = (view=='front' || view=='frontfull')? document.getElementById('tbodyFront'):document.getElementById('tbodyBack');
	
	removeAllChildren(container);
	for (var i=0;i<stockListArray.length;++i) {
		lastRow = (i==(stockListArray.length-1))? true:false;
		var row = createRow(i,view,lastRow);
		container.appendChild(row);
	}
	if (view=='frontfull') {
		setOverallDepotTrade();
		setOverallDepotTradeActual();
		setOverallDepotPerformanceDailyAbs();
		setOverallDepotPerformanceDailyPercent();
		setOverallDepotPerformanceDailyIndicator();
		setOverallDepotPerformanceAbs();
		setOverallDepotPerformancePercent();
		setOverallDepotPerformanceIndicatorID();
	}
	
	stopCacheIndicator('cacheindicatorFrontID');
}

function selectRow(event,row,moveAction) {
	if (selectedRow!=null) selectedRow = (selectedRow.getAttribute('tag') != row.getAttribute('tag'))? row:(!moveAction)? null:row;
	else selectedRow = row;
	var fadeDirection = (selectedRow != null)? 1:0;
	if (!moveAction) fadeButtonsBack(fadeDirection);
	setupStockTable('back');
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function setWidgetViewButton(valueFromPrefs) {
	buttonWidgetView.textElement.innerHTML = (valueFromPrefs==0)? getLocalizedString('Versteckt'):getLocalizedString('Komplett');
}

function changeWidgetViewButton() {
	var buttonText = buttonWidgetView.textElement.innerHTML;
	buttonWidgetView.textElement.innerHTML = (buttonText==getLocalizedString('Komplett'))? getLocalizedString('Versteckt'):getLocalizedString('Komplett');
}

function getWidgetViewFromInput(){
	return (buttonWidgetView.textElement.innerHTML==getLocalizedString('Komplett')? '1':'0');
}

/*//////////////////////
Updates the display of the two currency selection elements and sets the global variable "depotCurrency"
called by:
- onclick by every LI inside the two currency selection elements "depotCurrencyInput" and "stockCurrencyInput"
//////////////////////*/
function setCurrencyInput(inputId,wo) {
	var container = document.getElementById(inputId);
	for (var i=0;i<container.childNodes.length; i++) {
		if (container.childNodes[i].tagName == 'LI') {
			container.childNodes[i].childNodes[0].className = '';
			container.childNodes[i].childNodes[0].childNodes[0].src = container.childNodes[i].childNodes[0].childNodes[0].src.split('ac').join('lo');
		}
	}
	wo.className = 'act';
	wo.childNodes[0].src = wo.childNodes[0].src.split('lo').join('ac');
	if (inputId == 'stockCurrencyInput') setOverall();
	else if (inputId == 'depotCurrencyInput')  depotCurrency = wo.parentNode.id;
}

/*//////////////////////
Retrieves the selected value from the currency selection element "depotCurrencyInput" or "stockCurrencyInput" and returns it to the caller
called by:
- insertSymbol()
- storeStockList()
//////////////////////*/
function getCurrencyFromInput(inputId) {
	var container = document.getElementById(inputId);
	var returnValue = null;
	for (var i=0;i<container.childNodes.length; i++) {
		if (container.childNodes[i].tagName == 'LI') {
			if (container.childNodes[i].childNodes[0].className == 'act') {
				returnValue = container.childNodes[i].id;
			}
		}
	}
	return returnValue;
}

function setup() {
	if(window.widget) {
		startCacheIndicator('cacheindicatorFrontID');
		setVersionDisplay();
		buttonLookup	= new AppleGlassButton(document.getElementById('buttonLookupID'),getLocalizedString('Eintragen'),insertSymbol);
		buttonWidgetView  = new AppleGlassButton(document.getElementById('buttonWidgetViewID'),getLocalizedString('Komplett'),changeWidgetViewButton);
		buttonChange	= new AppleGlassButton(document.getElementById('buttonChangeID'),getLocalizedString('Ändern'),changeSymbol);
		buttonRemove	= new AppleGlassButton(document.getElementById('buttonRemoveID'),getLocalizedString('Löschen'),deleteSymbol);
		buttonDone		= new AppleGlassButton(document.getElementById('buttonDoneID'),getLocalizedString('Fertig'),hidePrefs);
		
		var stockNameListString = widget.preferenceForKey(createKey('stocknamelist'));
		var stockCodeListString = widget.preferenceForKey(createKey('stockcodelist'));
		var stockWKNListString = widget.preferenceForKey(createKey('stockwknlist'));
		var stockSharesListString = widget.preferenceForKey(createKey('stockshareslist'));
		var stockTradeListString = widget.preferenceForKey(createKey('stocktradelist'));
		var stockCurrencyListString = widget.preferenceForKey(createKey('stockcurrencylist'));
		
		setDepotNameToDiv(getDepotNameFromPrefs());
		setDepotNameToInput(getDepotNameFromPrefs());
		
		depotCurrency = (getDepotCurrencyFromPrefs()!=null)? getDepotCurrencyFromPrefs():0; //if null default euro
		setCurrencyToInput('depotCurrencyInput',depotCurrency);
		// default stock currency is euro
		setCurrencyToInput('stockCurrencyInput',0);
		
		customSortOrder = (getCustomSortOrderFromPrefs()!=null)? getCustomSortOrderFromPrefs():'false';
		widgetView = (getWidgetViewFromPrefs()!=null)? getWidgetViewFromPrefs():1;

		if (widgetView==1) {
			fader = new Fader(document.getElementById("frontTop1ID"), null, 500);
			fader.fadeIn();
		}
		setWidgetViewButton(widgetView);
		
		if (stockNameListString!='' && stockNameListString!=null) {
			var stockNameListArray = stockNameListString.split(',');
			var stockCodeListArray = stockCodeListString.split(',');
			var stockWKNListArray = stockWKNListString.split(',');
			var stockSharesListArray = stockSharesListString.split(',');
			var stockTradeListArray = stockTradeListString.split(',');
			stockListArray = new Array();
			
			if (stockCurrencyListString != null) {
				var stockCurrencyListArray = stockCurrencyListString.split(',');
			}
			else {
				stockCurrencyListArray = new Array();
				for (var i=0;i<stockNameListArray.length;i++) {
					stockCurrencyListArray[stockCurrencyListArray.length] = '0';				}
			}
			
			for (var i=0;i<stockNameListArray.length;i++) {
				var stockName = stockNameListArray[i];
				var stockCode = stockCodeListArray[i];
				var stockWKN = stockWKNListArray[i];
				var stockShares = stockSharesListArray[i];
				var stockTrade = stockTradeListArray[i];
				var stockCurrency = stockCurrencyListArray[i];
				//hook
				stockListArray[i] = new Array(stockName,stockCode,stockWKN,stockShares,stockTrade);
				stockListArray[i][10] = stockCurrency;
			}
			
			if (widgetView==1) {
				targetExtent = getExtent('front');
				resizeCanvas();
				setupElementsAfterResize('front');
				setupStockTable('front');
			}
			else switchView(true);
			
			setupStockTable("back");
			
		}
		else {
			stockListArray = new Array();
			setupStockTable('frontfull');
			stopCacheIndicator('cacheindicatorFrontID');
		}
	}
}


function storeStockList() {	
	var stockNameListArray = new Array();
	var stockCodeListArray = new Array();
	var stockWKNListArray = new Array();
	var stockSharesListArray = new Array();
	var stockTradeListArray = new Array();
	var stockCurrencyArray = new Array();

	for (var i=0;i<stockListArray.length;i++) {
		stockNameListArray[stockNameListArray.length] = stockListArray[i][0];
		stockCodeListArray[stockCodeListArray.length] = stockListArray[i][1];
		stockWKNListArray[stockWKNListArray.length] = stockListArray[i][2];
		stockSharesListArray[stockSharesListArray.length] = stockListArray[i][3];
		stockTradeListArray[stockTradeListArray.length] = stockListArray[i][4];
		// backward compatibility with versions prior 1.12 which don't have an individual currency set for each stock -> set it to 0 = euro
		stockCurrencyArray[stockCurrencyArray.length] = (stockListArray[i][10]!=null)? stockListArray[i][10]:0;
	}
	
	var stockNameListString = stockNameListArray.join();
	var stockCodeListString = stockCodeListArray.join();
	var stockWKNListString = stockWKNListArray.join();
	var stockSharesListString = stockSharesListArray.join();
	var stockTradeListString = stockTradeListArray.join();
	var stockCurrencyListString = stockCurrencyArray.join();

	widget.setPreferenceForKey(stockNameListString,createKey('stocknamelist'));
	widget.setPreferenceForKey(stockCodeListString,createKey('stockcodelist'));
	widget.setPreferenceForKey(stockWKNListString,createKey('stockwknlist'));
	widget.setPreferenceForKey(stockSharesListString,createKey('stockshareslist'));
	widget.setPreferenceForKey(stockTradeListString,createKey('stocktradelist'));
	widget.setPreferenceForKey(stockCurrencyListString,createKey('stockcurrencylist'));
	widget.setPreferenceForKey(getDepotNameFromInput(),createKey('depotname'));
	widget.setPreferenceForKey(getCurrencyFromInput('depotCurrencyInput'),createKey('depotcurrency'));
	widget.setPreferenceForKey(customSortOrder,createKey('customsortorder'));
	widget.setPreferenceForKey(getWidgetViewFromInput(),createKey('widgetview'));
}

function setupElementsAfterResize(side) {
	if (side=='back') {
		document.getElementById('versionDisplayID').style.top = targetExtent.y-29+'px';
		document.getElementById('buttonDoneID').style.top = targetExtent.y-57+'px';
		document.getElementById("backBottomID").style.top = (targetExtent.y-33)+'px';
	}
	else {
		document.getElementById("stockListFrontWrapper").style.height = (targetExtent.y-131)+'px';
		document.getElementById("flip").style.top = (targetExtent.y-29)+'px';
	}
	resizeCanvas();
}

function checkVersion() {
	queryComdirect('00','versioncheck','http://web.mac.com/cwilmanns/onheavygraphicrotations/DEPOTset_files/DEPOTset_version.xml');
}

/*
© Copyright 2005 Apple Computer, Inc. All rights reserved.
*/

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/
	
function showPrefs() {
	if (quoteTimer != null) {
		clearInterval(quoteTimer);
		quoteTimer = null;
	}
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	targetExtent = getExtent('back');
	if (widgetView==0) setupElementsAfterResize('back');
	
	if (window.widget) widget.prepareForTransition("ToBack");
	
	if (widgetView==1) setupElementsAfterResize('back');
	
	front.style.display="none";
	back.style.display="block";
	
	resizeCanvas();
	
	if (window.widget) setTimeout('widget.performTransition();', 0);
	document.getElementById('fliprollie').style.display = 'none';
}


function hidePrefs() {
	selectRow(null,selectedRow,false);
	storeStockList();
	clearInputBack();
	setDepotNameToDiv(getDepotNameFromPrefs());
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	targetExtent = (widgetView=='0')? {y:131}:getExtent('front');
	if (widgetView==1) setupElementsAfterResize('front');
	
	if (window.widget) widget.prepareForTransition("ToFront");
	
	if (widgetView==0) setupElementsAfterResize('front');

	
	back.style.display="none";
	front.style.display="block";
	
	resizeCanvas();
	
	if (window.widget) setTimeout ('widget.performTransition();', 0);
	
	if (quoteTimer == null) quoteTimer = setInterval('getStockQuotes();',getQuotesInterval);
	if (stockListArray.length>0) getStockQuotes();
	else setupStockTable('frontfull');
}

function createKey(key) {
	return (1==0? widget.identifier+'#'+key:key);
}

function getLocalizedString(key) {
	try {
		var ret = localizedStrings[key];
		if (ret === undefined) ret = key;
		return ret;
	}
	catch (ex) {}
	return key;
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
		
		var starttime = (new Date).getTime() - 13;		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event) {
	if (flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a,b,c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from,to,ease) {
    return from + (to - from) * ease;
}

function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

function Fader (element, callback, fadeTime, minOpacity, maxOpacity) {
	this.element = element;
	
	this.onFinished = callback;
	
	// Initialize for a fade-in; these values will be reset by the fadeIn/fadeOut functions
	this.fadingIn;
	this.now = 0.0;
	this.from = 0.0;
	this.to = 1.0;
		
	this.minOpacity = minOpacity ? minOpacity : 0;
	this.maxOpacity = maxOpacity ? maxOpacity : 1;
	
	this.setFadeTime(fadeTime);
	
	var self = this;
	
	this.nextFrame = function (animation, now, first, done) {
		self.element.style.opacity = now;
	}
}

/* 
 * Prototype method declarations; call these methods as 
 * nameOfFaderInstance.methodName();
 */
Fader.prototype.fadeOut = function () {
	if (this.fadingIn == false) {
		return;
	}
	var from = this.maxOpacity;
	if (this.element.style.opacity) {
		from = parseInt(this.element.style.opacity);
	}
	this.fadeTo(from, this.minOpacity);
	this.fadingIn = false;
}

Fader.prototype.fadeIn = function () {
	if (this.fadingIn == true) {
		return;
	}
	var from = this.minOpacity;
	if (this.element.style.opacity) {
		from = parseInt(this.element.style.opacity);
	}
	this.fadeTo(from, this.maxOpacity);
	this.fadingIn = true;
}

Fader.prototype.fadeTo = function (newFrom, newTo) {
	if (this.fadeAnimator) {
		this.fadeAnimator.stop();
		delete this.fadeAnimator;
	}
	
	this.fadeAnimator = new AppleAnimator(this.fadeTime, 13, newFrom, newTo, this.nextFrame);
	this.fadeAnimator.oncomplete = this.onFinished;
	this.fadeAnimator.start();
}

/*
 * Setter function for fade duration (floored at 250ms)
 */
Fader.prototype.setFadeTime  = function (fadeTime) {
	this.fadeTime = fadeTime > 250 ? fadeTime : 250;
}


/* borrowed from ??? */
var cachingIndicator = { interval:null, step:0 };
var cachingImagesLoaded = false;

function startCacheIndicator(whichSide) {
	stopCacheIndicator(whichSide);
	document.getElementById('errorDisplayFrontID').style.display = 'none';
	var obj = document.getElementById(whichSide);
	
	if(!cachingImagesLoaded) {
		for(var i = 0; i < 12; i++) {
			img = new Image();
			img.src = "Images/progress" + i + ".png";
		}
		cachingImagesLoaded = true;
	}
	animateCacheIndicator(whichSide);
	
	eval(whichSide+'.interval = setInterval(\'animateCacheIndicator("'+whichSide+'")\', 60);');
}

function stopCacheIndicator(whichSide) {
	var obj = document.getElementById(whichSide);
	var cachingIndicatorInterval = eval(whichSide+'.interval');
	if(cachingIndicatorInterval) { clearInterval(cachingIndicatorInterval); }
	cachingIndicator.interval = null;
	obj.style.backgroundImage = 'none';
	obj.style.paddingLeft = '1px';
}

function animateCacheIndicator(whichSide) {
	var obj = document.getElementById(whichSide);
	obj.style.backgroundImage = 'url(Images/progress'+cachingIndicator.step+'.png)';
	cachingIndicator.step++;
	cachingIndicator.step = (cachingIndicator.step > 11) ? 0 : cachingIndicator.step;
}

function getExtent(view) {
	var canvasHeight = (view=='front')? 98+Math.max(stockListArray.length*33-1,98)+33:124+(stockListArray.length*18)+33; // was 125+(stockListArray.length*18)+33
	var x = 571;
	var y = Math.max(canvasHeight,229);
	return {x:x, y:y}
}

function setCurrentExtent(ext) {	
	currentExtent = ext;
	if (window.widget) window.resizeTo(ext.x,ext.y);
}

function resizeCanvas() {
	setCurrentExtent({x:571, y:targetExtent.y});
}

function switchView(defaultView) {
	var initialViewVal = (defaultView)? true:false;
	if ( (widgetView=='1'&&!defaultView) || (widgetView=='0'&&defaultView) ) fadeView(0,initialViewVal);
	else resizeView(initialViewVal);
}

function fadeView(direction,defaultView) {
	var callback = (direction == 0)? resizeView(defaultView):null;
	fader0 = new Fader(document.getElementById("stockListFront"), callback, 500);
	fader1 = new Fader(document.getElementById("depotNameDisplayID"), null, 500, 0.25);
	fader3 = new Fader(document.getElementById("frontTop0ID"), null, 500);
	fader4 = new Fader(document.getElementById("frontTop1ID"), null, 500);
		
	if (direction==0) {
		fader0.fadeOut();
		fader1.fadeOut();
		fader3.fadeIn();
		fader4.fadeOut();
	}
	else {
		fader0.fadeIn();
		fader1.fadeIn();
		fader3.fadeOut();
		fader4.fadeIn();
		fadeButtons(1);
	}
}

function fadeButtons(direction) {
	faderButton0 = new Fader(document.getElementById("iconSwitch0ID"), null, 500);
	faderButton1 = new Fader(document.getElementById("iconSwitch1ID"), null, 500);
	if (direction==0) {
		faderButton0.fadeIn();
		faderButton1.fadeOut();
	}
	else {
		faderButton0.fadeOut();
		faderButton1.fadeIn();
	}
}

function fadeButtonsBack(direction) {
	faderButtonBack0 = new Fader(document.getElementById("buttonRemoveID"), null, 250, .5);
	faderButtonBack1 = new Fader(document.getElementById("buttonChangeID"), null, 250, .5);
	faderButtonBack2 = new Fader(document.getElementById("buttonMoveUpID"), null, 250, .5);
	faderButtonBack3 = new Fader(document.getElementById("buttonMoveDownID"), null, 250, .5);
	if (direction==0) {
		faderButtonBack0.fadeTo(1,.5);
		faderButtonBack1.fadeTo(1,.5);
		faderButtonBack2.fadeTo(1,.5);
		faderButtonBack3.fadeTo(1,.5);
	}
	else {
		faderButtonBack0.fadeTo(.5,1);
		faderButtonBack1.fadeTo(.5,1);
		faderButtonBack2.fadeTo(.5,1);
		faderButtonBack3.fadeTo(.5,1);
	}
}

function resizeView(defaultView) {
	var targetExtent = ( (widgetView=='1'&&!defaultView) || (widgetView=='0'&&defaultView) )? {y:131}:getExtent('front');
	var startingRect = new AppleRect (0, 0, canvasWidth, currentExtent.y);
	var finishingRect = new AppleRect (0, 0, canvasWidth, targetExtent.y);

	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	var currentAnimator = new AppleAnimator (500, 13);
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.start();
	if ( (widgetView=='1'&&!defaultView) || (widgetView=='0'&&defaultView) ) fadeButtons(0);
	if (!defaultView) widgetView = (parseInt(widgetView)%2)? '0':'1';

	currentExtent.y = targetExtent.y;
}

function rectHandler( rectAnimation, currentRect, startingRect, finishingRect ) {
	
	document.getElementById("stockListFrontWrapper").style.height = (currentRect.bottom-131)+'px';
	document.getElementById("flip").style.top = (currentRect.bottom-29)+'px';
	
	if(finishingRect && widgetView=='1') fadeView(1,false);
	window.resizeTo(currentRect.right, currentRect.bottom);
}

